"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReactTagsInput = void 0;
var _react = _interopRequireWildcard(require("react"));
var _Chip = _interopRequireDefault(require("@mui/material/Chip"));
var _styles = require("@material-ui/core/styles");
var _TextField = _interopRequireDefault(require("@mui/material/TextField"));
var _downshift = _interopRequireDefault(require("downshift"));
var _Typography = _interopRequireDefault(require("@mui/material/Typography"));
var _Box = _interopRequireDefault(require("@mui/material/Box"));
var _IconButton = _interopRequireDefault(require("@mui/material/IconButton"));
var _HighlightOffOutlined = _interopRequireDefault(require("@mui/icons-material/HighlightOffOutlined"));
var _material = require("@mui/material");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // import Chip from '@material-ui/core/Chip'
//import TextField from '@material-ui/core/TextField'
//import CancelIcon from '@material-ui/icons/Cancel' //Not used

const useStyles = (0, _styles.makeStyles)(theme => ({
  placeholderText: {
    '& input::placeholder': {
      fontSize: 15
    }
  },
  chip: {
    margin: theme.spacing(0.5, 0.25)
  },
  chipText: {
    '& .MuiChip-label': {
      fontSize: 15,
      overflowWrap: 'break-word',
      whiteSpace: 'normal',
      textOverflow: 'clip'
    },
    '& .MuiChip-deleteIcon': {
      height: 18
    }
  }
}));
const CustomTooltip = (0, _material.styled)(_ref => {
  let {
    className,
    ...props
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_material.Tooltip, _extends({}, props, {
    classes: {
      popper: className
    },
    disableInteractive: true
  }));
})(_ref2 => {
  let {
    theme
  } = _ref2;
  return {
    ["& .".concat(_material.tooltipClasses.tooltip)]: {
      backgroundColor: '#1877F2',
      color: '#FFFFFF',
      boxShadow: theme.shadows[1],
      borderRadius: 8,
      borderColor: '#1877F2',
      border: '2px solid #1877F2',
      fontSize: 11
      //fontWeight: "bold",
    },
    ["& .".concat(_material.tooltipClasses.arrow)]: {
      fontSize: 20,
      color: '#FFFFFF',
      '&::before': {
        backgroundColor: '#1877F2',
        border: '2px solid #1877F2'
      }
    }
  };
});
const ReactTagsInput = _ref3 => {
  let {
    ...props
  } = _ref3;
  const classes = useStyles();
  const {
    selectedTags,
    selectedItem,
    setSelectedItem,
    placeholder,
    tags,
    labelname,
    readOnlyTagInput,
    ...other
  } = props;
  const [inputValue, setInputValue] = _react.default.useState('');
  //const [selectedItem, setSelectedItem] = React.useState([])
  (0, _react.useEffect)(() => {
    setSelectedItem(tags);
  }, [tags]);
  (0, _react.useEffect)(() => {
    setSelectedItem(selectedItem);
    selectedTags(selectedItem);
  }, [selectedItem, selectedTags]);
  function handleKeyDown(event) {
    if (event.key === 'Enter') {
      var _event$target$value;
      const newSelectedItem = [...selectedItem];
      const duplicatedValues = newSelectedItem === null || newSelectedItem === void 0 ? void 0 : newSelectedItem.indexOf(event.target.value.trim());
      if (duplicatedValues !== -1) {
        setInputValue('');
        return;
      }
      if (!((_event$target$value = event.target.value) !== null && _event$target$value !== void 0 && _event$target$value.replace(/\s/g, '').length)) return;
      newSelectedItem === null || newSelectedItem === void 0 || newSelectedItem.push(event.target.value.trim());
      setSelectedItem(newSelectedItem);
      setInputValue('');
    }
    if (selectedItem !== null && selectedItem !== void 0 && selectedItem.length && !(inputValue !== null && inputValue !== void 0 && inputValue.length) && event.key === 'Backspace') {
      if (readOnlyTagInput === false)
        // dont allow backspace if read only mode
        setSelectedItem(selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.slice(0, (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.length) - 1));
    }
  }
  function handleChange(item) {
    var _newSelectedItem;
    let newSelectedItem = [...selectedItem];
    if (((_newSelectedItem = newSelectedItem) === null || _newSelectedItem === void 0 ? void 0 : _newSelectedItem.indexOf(item)) === -1) {
      newSelectedItem = [...newSelectedItem, item];
    }
    setInputValue('');
    setSelectedItem(newSelectedItem);
  }
  const handleDelete = item => () => {
    const newSelectedItem = [...selectedItem];
    newSelectedItem === null || newSelectedItem === void 0 || newSelectedItem.splice(newSelectedItem === null || newSelectedItem === void 0 ? void 0 : newSelectedItem.indexOf(item), 1);
    setSelectedItem(newSelectedItem);
  };
  function handleClearAll() {
    setInputValue('');
    setSelectedItem([]);
  }
  function handleInputChange(event) {
    setInputValue(event.target.value);
  }
  return /*#__PURE__*/_react.default.createElement(_downshift.default, {
    id: "downshift-multiple"
    //type="button"
    ,
    inputValue: inputValue,
    onChange: handleChange,
    selectedItem: selectedItem
  }, _ref4 => {
    let {
      getInputProps
    } = _ref4;
    const {
      onBlur,
      onChange,
      onFocus,
      ...inputProps
    } = getInputProps({
      onKeyDown: handleKeyDown,
      placeholder
    });
    return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_Box.default, {
      sx: {
        display: 'flex',
        justifyContent: 'space-between'
      }
    }, ' ', /*#__PURE__*/_react.default.createElement(_Typography.default, {
      component: "span",
      variant: "body2",
      sx: {
        mb: 1
      }
    }, /*#__PURE__*/_react.default.createElement("b", null, labelname)), (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.length) > 0 && readOnlyTagInput === false && /*#__PURE__*/_react.default.createElement(CustomTooltip, {
      title: 'Clear All ' + labelname,
      arrow: true
    }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
      onClick: () => handleClearAll(),
      style: {
        padding: 0,
        height: 'fit-content'
      }
    }, /*#__PURE__*/_react.default.createElement(_HighlightOffOutlined.default, {
      style: {
        color: 'red',
        fontSize: '1rem'
      }
    }))), ' '), /*#__PURE__*/_react.default.createElement("stack", {
      direction: "row"
    }, /*#__PURE__*/_react.default.createElement(_TextField.default, _extends({
      type: "text",
      size: "small",
      sx: {
        width: '100%',
        display: 'flex'
      },
      classes: {
        root: classes.placeholderText
      } //placeholder text css
      ,
      onKeyDown: e => {
        if (e.key === 'Enter') e.preventDefault();
      },
      InputProps: {
        readOnly: readOnlyTagInput ? true : false,
        style: {
          display: 'flex',
          flexWrap: 'wrap'
        },
        startAdornment: selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.map(item => /*#__PURE__*/_react.default.createElement(_Box.default, {
          sx: {
            mt: 1,
            mr: 1
          }
        }, /*#__PURE__*/_react.default.createElement(_Chip.default, {
          key: item,
          tabIndex: -1,
          label: item,
          sx: {
            p: 1
          },
          className: classes.chipText
          //Don't allow pointer when it is read pnly
          ,
          style: {
            pointerEvents: readOnlyTagInput ? 'none' : 'auto',
            height: 'auto' //adjust height when chip label test is wrapped
          }
          //onDelete={handleDelete(item)}
          //Don't allow to delete when it is read pnly
          ,
          onDelete: readOnlyTagInput ? () => {} : handleDelete(item)
          //Don't disable when it is read pnly
          //disabled={readOnlyTagInput ? true : false}
          // deleteIcon={<CancelIcon disabled={readOnlyTagInput ? true : false}/>}
          // InputProps={{
          //   readOnly: readOnlyTagInput ? true : false
          // }}
        }))),
        // endAdornment: (
        //   <InputAdornment position="start">
        //     <IconButton
        //       onClick={() => {
        //         console.log('CLear all')
        //       }}
        //     >
        //       <CloseOutlinedIcon />
        //     </IconButton>
        //   </InputAdornment>
        // ),

        onBlur,
        onChange: event => {
          handleInputChange(event);
          onChange(event);
        },
        onFocus
      }
    }, other, inputProps))));
  });
};
exports.ReactTagsInput = ReactTagsInput;